Index: kernel/arch/arm64/src/start.S
===================================================================
--- kernel/arch/arm64/src/start.S	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ kernel/arch/arm64/src/start.S	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,288 @@
+/*
+ * Copyright (c) 2015 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <abi/asmtool.h>
+#include <arch/boot/boot.h>
+#include <arch/mm/km.h>
+#include <arch/mm/page.h>
+#include <arch/regutils.h>
+
+.section K_TEXT_START, "ax"
+
+SYMBOL(kernel_image_start)
+	/*
+	 * Parameters:
+	 * x0 is kernel entry point (kernel_image_start).
+	 * x1 is pointer to the bootinfo structure.
+	 *
+	 * MMU must be disabled at this point.
+	 */
+
+	/* Get address of the main memory and remember it. */
+	adrp x20, kernel_image_start - BOOT_OFFSET
+	adrp x2, physmem_base
+	/* add x2, x2, #:lo12:physmem_base */
+	str x20, [x2]
+
+	/*
+	 * Set up address translation that identity maps the gigabyte area that
+	 * is holding the current execution page.
+	 */
+
+	/* Prepare the level 0 page table. */
+	adrp x2, lower_page_table_level0
+	lsr x3, x20, #PTL0_VA_SHIFT
+	and x3, x3, #PTL0_VA_MASK
+	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
+	mov x3, #( \
+	    1 << PTE_ACCESS_SHIFT | \
+	    PTE_L012_TYPE_TABLE << PTE_TYPE_SHIFT | \
+	    1 << PTE_PRESENT_SHIFT)
+	adrp x4, lower_page_table_level1
+	lsr x4, x4, #FRAME_WIDTH
+	orr x3, x3, x4, lsl #PTE_NEXT_LEVEL_ADDRESS_SHIFT
+	str x3, [x2]
+
+	/* Prepare the level 1 page table. */
+	adrp x2, lower_page_table_level1
+	lsr x3, x20, #PTL1_VA_SHIFT
+	and x3, x3, #PTL1_VA_MASK
+	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
+	mov x3, #( \
+	    1 << PTE_ACCESS_SHIFT | \
+	    MAIR_EL1_DEVICE_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
+	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
+	    1 << PTE_PRESENT_SHIFT)
+	lsr x4, x20, #FRAME_WIDTH
+	orr x3, x3, x4, lsl #PTE_OUTPUT_ADDRESS_SHIFT
+	str x3, [x2]
+
+	/*
+	 * Set up address translation that maps the first gigabyte of the kernel
+	 * identity virtual address space to the first gigabyte of the physical
+	 * memory.
+	 */
+
+	mov x21, #KM_ARM64_IDENTITY_START
+
+	/* Prepare the level 0 page table. */
+	adrp x2, upper_page_table_level0
+	lsr x3, x21, #PTL0_VA_SHIFT
+	and x3, x3, #PTL0_VA_MASK
+	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
+	mov x3, #( \
+	    1 << PTE_ACCESS_SHIFT | \
+	    PTE_L012_TYPE_TABLE << PTE_TYPE_SHIFT | \
+	    1 << PTE_PRESENT_SHIFT)
+	adrp x4, upper_page_table_level1
+	lsr x4, x4, #FRAME_WIDTH
+	orr x3, x3, x4, lsl #PTE_NEXT_LEVEL_ADDRESS_SHIFT
+	str x3, [x2]
+
+	/* Prepare the level 1 page table. */
+	adrp x2, upper_page_table_level1
+	lsr x3, x21, #PTL1_VA_SHIFT
+	and x3, x3, #PTL1_VA_MASK
+	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
+	mov x3, #( \
+	    1 << PTE_ACCESS_SHIFT | \
+	    MAIR_EL1_DEVICE_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
+	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
+	    1 << PTE_PRESENT_SHIFT)
+	lsr x4, x20, #FRAME_WIDTH
+	orr x3, x3, x4, lsl #PTE_OUTPUT_ADDRESS_SHIFT
+	str x3, [x2]
+
+	/* Make sure there are not any stale TLB entries. */
+	tlbi vmalle1is
+	dsb ish
+
+	/*
+	 * Set TCR_EL1:
+	 * [63:39] - Reserved 0.
+	 * [38]    - TBI1=0, top byte of an address is used in the address
+	 *           calculation for the TTBR1_EL1 region.
+	 * [37]    - TBI0=0, top byte of an address is used in the address
+	 *           calculation for the TTBR0_EL1 region.
+	 * [36]    - AS=1, the upper 16 bits of TTBR0_EL1 and TTBR1_EL1 are used
+	 *           for allocation and matching in the TLB.
+	 * [35]    - Reserved 0.
+	 * [34:32] - IPS=101, intermediate physical address size is 48 bits,
+	 *           256TB.
+	 * [31:30] - TG1=10, TTBR1_EL1 granule size is 4KB.
+	 * [29:28] - SH1=11, memory associated with translation table walks
+	 *           using TTBR1_EL1 is inner shareable.
+	 * [27:26] - ORGN1=01, memory associated with translation table walks
+	 *           using TTBR1_EL1 is normal memory, outer write-through
+	 *           cacheable.
+	 * [25:24] - IRGN1=01, memory associated with translation table walks
+	 *           using TTBR1_EL1 is normal memory, inner write-back
+	 *           write-allocate cacheable.
+	 * [23]    - EPD1=0, perform translation table walks using TTBR1_EL1.
+	 * [22]    - A1=0, TTBR0_EL1.ASID defines the ASID.
+	 * [21:16] - T1SZ=010000, size of the memory region addressed by
+	 *           TTBR1_EL1 is 2^(64 - 16) bytes.
+	 * [15:14] - TG0=00, TTBR0_EL1 granule size is 4KB.
+	 * [13:12] - SH0=11, memory associated with translation table walks
+	 *           using TTBR0_EL1 is inner shareable.
+	 * [11:10] - ORGN0=01, memory associated with translation table walks
+	 *           using TTBR0_EL1 is normal memory, outer write-through
+	 *           cacheable.
+	 * [9:8]   - IRGN0=01, memory associated with translation table walks
+	 *           using TTBR0_EL1 is normal memory, inner write-back
+	 *           write-allocate cacheable.
+	 * [7]     - EPD0=0, perform translation table walks using TTBR0.
+	 * [6]     - Reserved 0.
+	 * [5:0]   - T0SZ=010000, size of the memory region addressed by
+	 *           TTBR0_EL1 is 2^(64 - 16) bytes.
+	 */
+	ldr x2, =0x00000015b5103510
+	msr tcr_el1, x2
+
+	/* Initialize memory attributes. */
+	ldr x2, =(MAIR_EL1_DEVICE_MEMORY_ATTR << \
+	    (MAIR_EL1_DEVICE_MEMORY_INDEX * MAIR_EL1_ATTR_SHIFT) | \
+	    MAIR_EL1_NORMAL_MEMORY_ATTR << \
+	    (MAIR_EL1_NORMAL_MEMORY_INDEX * MAIR_EL1_ATTR_SHIFT))
+	msr mair_el1, x2
+
+	/* Set translation tables. */
+	adrp x2, lower_page_table_level0
+	msr ttbr0_el1, x2
+	adrp x2, upper_page_table_level0
+	msr ttbr1_el1, x2
+	isb
+
+	/*
+	 * Set SCTLR_EL1:
+	 * [31:30] - Reserved 0.
+	 * [29:28] - Reserved 1.
+	 * [27]    - Reserved 0.
+	 * [26]    - UCI=0, any attempt to execute cache maintenance
+	 *           instructions at EL0 is trapped to EL1.
+	 * [25]    - EE=0, explicit data accesses at EL1, and stage 1
+	 *           translation table walks in the EL1&0 translation regime are
+	 *           little-endian.
+	 * [24]    - E0E=0, explicit data accesses at EL1 are little-endian.
+	 * [23:22] - Reserved 1.
+	 * [21]    - Reserved 0.
+	 * [20]    - Reserved 1.
+	 * [19]    - WXN=0, regions with write permission are not forced to
+	 *           Execute Never.
+	 * [18]    - nTWE=0, any attempt to execute WFE at EL0 is trapped to
+	 *           EL1.
+	 * [17]    - Reserved 0.
+	 * [16]    - nTWI=0, any attempt to execute WFI at EL0 is trapped to
+	 *           EL1.
+	 * [15]    - UCT=0, accesses to CTR_EL0 from EL0 are trapped to EL1.
+	 * [14]    - DZE=0, any attempt to execute DC ZVA at EL0 is trapped to
+	 *           EL1.
+	 * [13]    - Reserved 0.
+	 * [12]    - I=1, this control has no effect on the cacheability of
+	 *           instruction access to normal memory.
+	 * [11]    - Reserved 1.
+	 * [10]    - Reserved 0.
+	 * [9]     - UMA=0, any attempt to execute MSR/MRS that accesses DAIF at
+	 *           EL0 is trapped to EL1.
+	 * [8]     - SED=1, SETEND is undefined at EL0 using AArch32.
+	 * [7]     - ITD=1, disables some uses of IT at EL0 using AArch32.
+	 * [6]     - Reserved 0.
+	 * [5]     - CP15BEN=0, CP15DMB/DSB/ISB is undefined at EL0 using
+	 *           AArch32.
+	 * [4]     - SA0=1, use of stack pointer with load/store at EL0 must be
+	 *           aligned to a 16-byte boundary.
+	 * [3]     - SA=1, use of stack pointer with load/store at EL1 must be
+	 *           aligned to a 16-byte boundary.
+	 * [2]     - C=1, this control has no effect on the cacheability of data
+	 *           access to normal memory from EL0 and EL1, and normal memory
+	 *           accesses to the EL1&0 stage 1 translation tables.
+	 * [1]     - A=0, instructions that load/store registers (other than
+	 *           load/store exclusive and load-acquire/store-release) do not
+	 *           check that the address being accessed is aligned to the
+	 *           size of the data element(s) being accessed.
+	 * [0]     - M=1, EL1 and EL0 stage 1 address translation enabled.
+	 */
+	ldr w2, =0x30d0199d
+	msr sctlr_el1, x2
+	isb
+
+	/*
+	 * MMU is enabled at this point (SCTLR_EL1.M=1), switch to the kernel
+	 * mapping.
+	 */
+	ldr x2, =1f
+	br x2
+1:
+
+	/* Disable access to low addresses. */
+	mov x2, #0
+	msr ttbr0_el1, x2
+	isb
+	tlbi vmalle1is
+	dsb ish
+
+	/* Jump on a temporary stack. */
+	ldr x2, =temp_stack
+	mov sp, x2
+
+	/* Create the first stack frame. */
+	mov x29, #0
+	mov x30, #0
+	stp x29, x30, [sp, #-16]!
+	mov x29, sp
+
+	/* PA2KA(bootinfo). */
+	sub x1, x1, x20
+	ldr x2, =KM_ARM64_IDENTITY_START
+	add x1, x1, x2
+
+	bl arm64_pre_main
+	bl main_bsp
+
+.section K_DATA_START, "ax"
+
+	/* Page tables. */
+.align 12
+lower_page_table_level0:
+	.space 4096
+lower_page_table_level1:
+	.space 4096
+upper_page_table_level0:
+	.space 4096
+upper_page_table_level1:
+	.space 4096
+
+	/* Physical memory base address. */
+.align 12
+SYMBOL(physmem_base)
+	.quad 0
+
+	/* Temporary stack. */
+.align 10
+	.space 1024
+temp_stack:
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -92,5 +92,4 @@
 	arch/$(KARCH)/src/ddi/ddi.c \
 	arch/$(KARCH)/src/drivers/i8254.c \
-	arch/$(KARCH)/src/drivers/i8259.c \
 	arch/$(KARCH)/src/boot/multiboot.S \
 	arch/$(KARCH)/src/boot/multiboot2.S \
Index: kernel/arch/ia32/include/arch/interrupt.h
===================================================================
--- kernel/arch/ia32/include/arch/interrupt.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/include/arch/interrupt.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -63,6 +63,7 @@
 /* NS16550 at COM1 */
 #define IRQ_NS16550   4
-#define IRQ_PIC_SPUR  7
+#define IRQ_PIC0_SPUR 7
 #define IRQ_MOUSE     12
+#define IRQ_PIC1_SPUR 15
 
 /* This one must have four least significant bits set to ones */
@@ -81,17 +82,11 @@
 #define VECTOR_XM                 (IVT_EXCBASE + EXC_XM)
 #define VECTOR_CLK                (IVT_IRQBASE + IRQ_CLK)
-#define VECTOR_PIC_SPUR           (IVT_IRQBASE + IRQ_PIC_SPUR)
+#define VECTOR_PIC0_SPUR          (IVT_IRQBASE + IRQ_PIC0_SPUR)
+#define VECTOR_PIC1_SPUR          (IVT_IRQBASE + IRQ_PIC1_SPUR)
 #define VECTOR_SYSCALL            IVT_FREEBASE
 #define VECTOR_TLB_SHOOTDOWN_IPI  (IVT_FREEBASE + 1)
 #define VECTOR_DEBUG_IPI          (IVT_FREEBASE + 2)
 
-extern void (*disable_irqs_function)(uint16_t);
-extern void (*enable_irqs_function)(uint16_t);
-extern void (*eoi_function)(void);
-extern const char *irqs_info;
-
 extern void interrupt_init(void);
-extern void trap_virtual_enable_irqs(uint16_t);
-extern void trap_virtual_disable_irqs(uint16_t);
 
 #endif
Index: kernel/arch/ia32/include/arch/mm/as.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/include/arch/mm/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -37,4 +37,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
Index: kernel/arch/ia32/include/arch/smp/apic.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/apic.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/include/arch/smp/apic.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -43,4 +43,5 @@
 #include <cpu.h>
 #include <stdint.h>
+#include <genarch/pic/pic_ops.h>
 
 #define FIXED  (0 << 0)
@@ -347,4 +348,6 @@
 } io_apic_id_t;
 
+extern pic_ops_t apic_pic_ops;
+
 extern volatile uint32_t *l_apic;
 extern volatile uint32_t *io_apic;
@@ -356,5 +359,5 @@
 
 extern void l_apic_init(void);
-extern void l_apic_eoi(void);
+extern void l_apic_eoi(unsigned int);
 extern int l_apic_send_custom_ipi(uint8_t, uint8_t);
 extern int l_apic_broadcast_custom_ipi(uint8_t);
Index: kernel/arch/ia32/src/debug/stacktrace.c
===================================================================
--- kernel/arch/ia32/src/debug/stacktrace.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/debug/stacktrace.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -67,12 +67,12 @@
 bool uspace_frame_pointer_prev(stack_trace_context_t *ctx, uintptr_t *prev)
 {
-	return !copy_from_uspace((void *) prev,
-	    (uint32_t *) ctx->fp + FRAME_OFFSET_FP_PREV, sizeof(*prev));
+	return !copy_from_uspace(prev,
+	    ctx->fp + sizeof(uintptr_t) * FRAME_OFFSET_FP_PREV, sizeof(*prev));
 }
 
 bool uspace_return_address_get(stack_trace_context_t *ctx, uintptr_t *ra)
 {
-	return !copy_from_uspace((void *) ra,
-	    (uint32_t *) ctx->fp + FRAME_OFFSET_RA, sizeof(*ra));
+	return !copy_from_uspace(ra,
+	    ctx->fp + sizeof(uintptr_t) * FRAME_OFFSET_RA, sizeof(*ra));
 }
 
Index: kernel/arch/ia32/src/drivers/i8254.c
===================================================================
--- kernel/arch/ia32/src/drivers/i8254.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/drivers/i8254.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -42,5 +42,5 @@
 #include <arch/cycle.h>
 #include <arch/interrupt.h>
-#include <arch/drivers/i8259.h>
+#include <genarch/drivers/i8259/i8259.h>
 #include <arch/drivers/i8254.h>
 #include <cpu.h>
@@ -96,8 +96,8 @@
 {
 	pio_write_8(CLK_PORT4, 0x36);
-	pic_disable_irqs(1 << IRQ_CLK);
+	i8259_disable_irqs(1 << IRQ_CLK);
 	pio_write_8(CLK_PORT1, (CLK_CONST / HZ) & 0xf);
 	pio_write_8(CLK_PORT1, (CLK_CONST / HZ) >> 8);
-	pic_enable_irqs(1 << IRQ_CLK);
+	i8259_enable_irqs(1 << IRQ_CLK);
 }
 
@@ -143,7 +143,11 @@
 	o2 |= pio_read_8(CLK_PORT1) << 8;
 
+	uint32_t delta = (t1 - t2) - (o1 - o2);
+	if (!delta)
+		delta = 1;
+
 	CPU->delay_loop_const =
-	    ((MAGIC_NUMBER * LOOPS) / 1000) / ((t1 - t2) - (o1 - o2)) +
-	    (((MAGIC_NUMBER * LOOPS) / 1000) % ((t1 - t2) - (o1 - o2)) ? 1 : 0);
+	    ((MAGIC_NUMBER * LOOPS) / 1000) / delta +
+	    (((MAGIC_NUMBER * LOOPS) / 1000) % delta ? 1 : 0);
 
 	uint64_t clk1 = get_cycle();
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/ia32.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -47,8 +47,8 @@
 #include <arch/boot/boot.h>
 #include <arch/drivers/i8254.h>
-#include <arch/drivers/i8259.h>
 #include <genarch/acpi/acpi.h>
 #include <genarch/drivers/ega/ega.h>
 #include <genarch/drivers/i8042/i8042.h>
+#include <genarch/drivers/i8259/i8259.h>
 #include <genarch/drivers/ns16550/ns16550.h>
 #include <genarch/drivers/legacy/ia32/io.h>
@@ -58,4 +58,5 @@
 #include <genarch/multiboot/multiboot.h>
 #include <genarch/multiboot/multiboot2.h>
+#include <genarch/pic/pic_ops.h>
 #include <arch/pm.h>
 #include <arch/vreg.h>
@@ -109,5 +110,9 @@
 
 		/* PIC */
-		i8259_init();
+		i8259_init((i8259_t *) I8259_PIC0_BASE,
+		    (i8259_t *) I8259_PIC1_BASE, IVT_IRQBASE);
+
+		/* Set PIC operations. */
+		pic_ops = &i8259_pic_ops;
 	}
 }
@@ -184,6 +189,6 @@
 			indev_t *kbrd = kbrd_wire(kbrd_instance, sink);
 			i8042_wire(i8042_instance, kbrd);
-			trap_virtual_enable_irqs(1 << IRQ_KBD);
-			trap_virtual_enable_irqs(1 << IRQ_MOUSE);
+			pic_ops->enable_irqs(1 << IRQ_KBD);
+			pic_ops->enable_irqs(1 << IRQ_MOUSE);
 		}
 	}
@@ -210,5 +215,5 @@
 			indev_t *srln = srln_wire(srln_instance, sink);
 			ns16550_wire(ns16550_instance, srln);
-			trap_virtual_enable_irqs(1 << IRQ_NS16550);
+			pic_ops->enable_irqs(1 << IRQ_NS16550);
 		}
 #endif
@@ -221,6 +226,5 @@
 #endif
 
-	if (irqs_info != NULL)
-		sysinfo_set_item_val(irqs_info, NULL, true);
+	sysinfo_set_item_val(pic_ops->get_name(), NULL, true);
 }
 
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/interrupt.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -39,5 +39,6 @@
 #include <debug.h>
 #include <panic.h>
-#include <arch/drivers/i8259.h>
+#include <genarch/drivers/i8259/i8259.h>
+#include <genarch/pic/pic_ops.h>
 #include <halt.h>
 #include <cpu.h>
@@ -61,8 +62,5 @@
  */
 
-void (*disable_irqs_function)(uint16_t irqmask) = NULL;
-void (*enable_irqs_function)(uint16_t irqmask) = NULL;
-void (*eoi_function)(void) = NULL;
-const char *irqs_info = NULL;
+pic_ops_t *pic_ops = NULL;
 
 void istate_decode(istate_t *istate)
@@ -88,13 +86,4 @@
 	    istate_from_uspace(istate) ? istate->esp :
 	    (uint32_t) &istate->esp);
-}
-
-static void trap_virtual_eoi(void)
-{
-	if (eoi_function)
-		eoi_function();
-	else
-		panic("No eoi_function.");
-
 }
 
@@ -179,5 +168,5 @@
     istate_t *istate __attribute__((unused)))
 {
-	trap_virtual_eoi();
+	pic_ops->eoi(0);
 	tlb_shootdown_ipi_recv();
 }
@@ -192,5 +181,5 @@
 	bool ack = false;
 	assert(inum < IRQ_COUNT);
-	assert((inum != IRQ_PIC_SPUR) && (inum != IRQ_PIC1));
+	assert(inum != IRQ_PIC1);
 
 	irq_t *irq = irq_dispatch_and_lock(inum);
@@ -202,5 +191,5 @@
 		if (irq->preack) {
 			/* Send EOI before processing the interrupt */
-			trap_virtual_eoi();
+			pic_ops->eoi(inum);
 			ack = true;
 		}
@@ -208,14 +197,27 @@
 		irq_spinlock_unlock(&irq->lock, false);
 	} else {
-		/*
-		 * Spurious interrupt.
-		 */
 #ifdef CONFIG_DEBUG
-		printf("cpu%u: spurious interrupt (inum=%u)\n", CPU->id, inum);
+		log(LF_ARCH, LVL_DEBUG, "cpu%u: unhandled IRQ %u", CPU->id,
+		    inum);
 #endif
 	}
 
 	if (!ack)
-		trap_virtual_eoi();
+		pic_ops->eoi(inum);
+}
+
+static void pic_spurious(unsigned int n, istate_t *istate)
+{
+	unsigned int inum = n - IVT_IRQBASE;
+	if (!pic_ops->is_spurious(inum)) {
+		/* This is actually not a spurious IRQ, so proceed as usual. */
+		irq_interrupt(n, istate);
+		return;
+	}
+	pic_ops->handle_spurious(n);
+#ifdef CONFIG_DEBUG
+	log(LF_ARCH, LVL_DEBUG, "cpu%u: PIC spurious interrupt %u", CPU->id,
+	    inum);
+#endif
 }
 
@@ -228,5 +230,6 @@
 
 	for (i = 0; i < IRQ_COUNT; i++) {
-		if ((i != IRQ_PIC_SPUR) && (i != IRQ_PIC1))
+		if ((i != IRQ_PIC0_SPUR) && (i != IRQ_PIC1_SPUR) &&
+		    (i != IRQ_PIC1))
 			exc_register(IVT_IRQBASE + i, "irq", true,
 			    (iroutine_t) irq_interrupt);
@@ -239,4 +242,8 @@
 	exc_register(VECTOR_GP, "gp_fault", true, (iroutine_t) gp_fault);
 	exc_register(VECTOR_XM, "simd_fp", true, (iroutine_t) simd_fp_exception);
+	exc_register(VECTOR_PIC0_SPUR, "pic0_spurious", true,
+	    (iroutine_t) pic_spurious);
+	exc_register(VECTOR_PIC1_SPUR, "pic1_spurious", true,
+	    (iroutine_t) pic_spurious);
 
 #ifdef CONFIG_SMP
@@ -246,20 +253,4 @@
 }
 
-void trap_virtual_enable_irqs(uint16_t irqmask)
-{
-	if (enable_irqs_function)
-		enable_irqs_function(irqmask);
-	else
-		panic("No enable_irqs_function.");
-}
-
-void trap_virtual_disable_irqs(uint16_t irqmask)
-{
-	if (disable_irqs_function)
-		disable_irqs_function(irqmask);
-	else
-		panic("No disable_irqs_function.");
-}
-
 /** @}
  */
Index: kernel/arch/ia32/src/smp/apic.c
===================================================================
--- kernel/arch/ia32/src/smp/apic.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/smp/apic.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -47,4 +47,5 @@
 #include <arch.h>
 #include <ddi/irq.h>
+#include <genarch/pic/pic_ops.h>
 
 #ifdef CONFIG_SMP
@@ -63,4 +64,17 @@
  */
 
+static const char *apic_get_name(void);
+static bool l_apic_is_spurious(unsigned int);
+static void l_apic_handle_spurious(unsigned int);
+
+pic_ops_t apic_pic_ops = {
+	.get_name = apic_get_name,
+	.enable_irqs = io_apic_enable_irqs,
+	.disable_irqs = io_apic_disable_irqs,
+	.eoi = l_apic_eoi,
+	.is_spurious = l_apic_is_spurious,
+	.handle_spurious = l_apic_handle_spurious,
+};
+
 /*
  * These variables either stay configured as initilalized, or are changed by
@@ -125,4 +139,18 @@
 #endif /* LAPIC_VERBOSE */
 
+const char *apic_get_name(void)
+{
+	return "apic";
+}
+
+bool l_apic_is_spurious(unsigned int n)
+{
+	return n == VECTOR_APIC_SPUR;
+}
+
+void l_apic_handle_spurious(unsigned int n)
+{
+}
+
 /** APIC spurious interrupt handler.
  *
@@ -134,7 +162,4 @@
     istate_t *istate __attribute__((unused)))
 {
-#ifdef CONFIG_DEBUG
-	log(LF_ARCH, LVL_DEBUG, "cpu%u: APIC spurious interrupt", CPU->id);
-#endif
 }
 
@@ -175,8 +200,5 @@
 	    (iroutine_t) apic_spurious);
 
-	enable_irqs_function = io_apic_enable_irqs;
-	disable_irqs_function = io_apic_disable_irqs;
-	eoi_function = l_apic_eoi;
-	irqs_info = "apic";
+	pic_ops = &apic_pic_ops;
 
 	/*
@@ -508,5 +530,5 @@
 
 /** Local APIC End of Interrupt. */
-void l_apic_eoi(void)
+void l_apic_eoi(unsigned int ignored)
 {
 	l_apic[EOI] = 0;
Index: kernel/arch/ia32/src/smp/smp.c
===================================================================
--- kernel/arch/ia32/src/smp/smp.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/smp/smp.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -55,5 +55,5 @@
 #include <log.h>
 #include <mem.h>
-#include <arch/drivers/i8259.h>
+#include <genarch/drivers/i8259/i8259.h>
 #include <cpu.h>
 
@@ -130,5 +130,5 @@
 	pio_write_8((ioport8_t *) 0x71, 0xa);
 
-	pic_disable_irqs(0xffff);
+	i8259_disable_irqs(0xffff);
 	apic_init();
 
Index: kernel/arch/ia32/src/userspace.c
===================================================================
--- kernel/arch/ia32/src/userspace.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia32/src/userspace.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -70,5 +70,5 @@
 	    : [eflags_mask] "i" (~EFLAGS_NT),
 	      [udata_des] "i" (GDT_SELECTOR(UDATA_DES) | PL_USER),
-	      [stack_top] "r" ((uint8_t *) kernel_uarg->uspace_stack +
+	      [stack_top] "r" (kernel_uarg->uspace_stack +
 	      kernel_uarg->uspace_stack_size),
 	      [eflags] "r" ((eflags & ~(EFLAGS_NT)) | EFLAGS_IF),
Index: kernel/arch/ia64/Makefile.inc
===================================================================
--- kernel/arch/ia64/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -30,5 +30,4 @@
 COMMON_CFLAGS += -mconstant-gp -fno-unwind-tables -mfixed-range=f32-f127
 
-AFLAGS += -mconstant-gp
 LDFLAGS += -Wl,-EL
 
Index: kernel/arch/ia64/include/arch/interrupt.h
===================================================================
--- kernel/arch/ia64/include/arch/interrupt.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/include/arch/interrupt.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -92,6 +92,4 @@
 extern void disabled_fp_register(unsigned int, istate_t *);
 
-extern void trap_virtual_enable_irqs(uint16_t);
-
 void exception_init(void);
 #endif
Index: kernel/arch/ia64/include/arch/istate.h
===================================================================
--- kernel/arch/ia64/include/arch/istate.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/include/arch/istate.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -71,5 +71,5 @@
 _NO_TRACE static inline int istate_from_uspace(istate_t *istate)
 {
-	return (istate->cr_iip) < 0xe000000000000000ULL;
+	return istate->cr_ipsr.cpl == PSR_CPL_USER;
 }
 
Index: kernel/arch/ia64/include/arch/mm/as.h
===================================================================
--- kernel/arch/ia64/include/arch/mm/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/include/arch/mm/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -37,4 +37,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0xe000000000000000)
Index: kernel/arch/ia64/include/arch/mm/page.h
===================================================================
--- kernel/arch/ia64/include/arch/mm/page.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/include/arch/mm/page.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,4 +38,5 @@
 
 #include <arch/mm/frame.h>
+#include <arch/register.h>
 
 #ifndef __ASSEMBLER__
@@ -76,6 +77,6 @@
 
 /** Privilege Levels. Only the most and the least privileged ones are ever used. */
-#define PL_KERNEL  0x00
-#define PL_USER    0x03
+#define PL_KERNEL  PSR_CPL_KERNEL
+#define PL_USER    PSR_CPL_USER
 
 /* Access Rigths. Only certain combinations are used by the kernel. */
Index: kernel/arch/ia64/include/arch/register.h
===================================================================
--- kernel/arch/ia64/include/arch/register.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/include/arch/register.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -57,4 +57,7 @@
 #define PSR_RT_MASK   (1 << 27)
 #define PSR_IT_MASK   (1 << 36)
+
+#define PSR_CPL_USER   3
+#define PSR_CPL_KERNEL 0
 
 #define PSR_CPL_SHIFT         32
Index: kernel/arch/ia64/src/ia64.c
===================================================================
--- kernel/arch/ia64/src/ia64.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/src/ia64.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -244,11 +244,11 @@
 	 * uspace_stack_size / 2 bytes.
 	 */
-	switch_to_userspace((uintptr_t) kernel_uarg->uspace_entry,
-	    ((uintptr_t) kernel_uarg->uspace_stack) +
+	switch_to_userspace(kernel_uarg->uspace_entry,
+	    kernel_uarg->uspace_stack +
 	    kernel_uarg->uspace_stack_size / 2 -
 	    ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT),
-	    ((uintptr_t) kernel_uarg->uspace_stack) +
+	    kernel_uarg->uspace_stack +
 	    kernel_uarg->uspace_stack_size / 2,
-	    (uintptr_t) kernel_uarg->uspace_uarg, psr.value, rsc.value);
+	    kernel_uarg->uspace_uarg, psr.value, rsc.value);
 
 	while (true)
Index: kernel/arch/ia64/src/interrupt.c
===================================================================
--- kernel/arch/ia64/src/interrupt.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/src/interrupt.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -301,8 +301,4 @@
 }
 
-void trap_virtual_enable_irqs(uint16_t irqmask)
-{
-}
-
 void exception_init(void)
 {
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -464,7 +464,10 @@
 }
 
-static bool is_kernel_fault(uintptr_t va)
+static bool is_kernel_fault(istate_t *istate, uintptr_t va)
 {
 	region_register_t rr;
+
+	if (istate_from_uspace(istate))
+		return false;
 
 	rr.word = rr_read(VA2VRN(va));
@@ -484,7 +487,7 @@
 	pte_t t;
 
+	assert(istate_from_uspace(istate));
+
 	va = istate->cr_ifa; /* faulting address */
-
-	assert(!is_kernel_fault(va));
 
 	bool found = page_mapping_find(AS, va, true, &t);
@@ -587,5 +590,5 @@
 	as_t *as = AS;
 
-	if (is_kernel_fault(va)) {
+	if (is_kernel_fault(istate, va)) {
 		if (va < end_of_identity) {
 			/*
@@ -648,5 +651,5 @@
 	va = istate->cr_ifa;  /* faulting address */
 
-	if (is_kernel_fault(va))
+	if (is_kernel_fault(istate, va))
 		as = AS_KERNEL;
 
@@ -680,7 +683,7 @@
 	pte_t t;
 
+	assert(istate_from_uspace(istate));
+
 	va = istate->cr_ifa;  /* faulting address */
-
-	assert(!is_kernel_fault(va));
 
 	bool found = page_mapping_find(AS, va, true, &t);
@@ -716,5 +719,5 @@
 	va = istate->cr_ifa;  /* faulting address */
 
-	if (is_kernel_fault(va))
+	if (is_kernel_fault(istate, va))
 		as = AS_KERNEL;
 
@@ -752,7 +755,7 @@
 	pte_t t;
 
+	assert(istate_from_uspace(istate));
+
 	va = istate->cr_ifa;  /* faulting address */
-
-	assert(!is_kernel_fault(va));
 
 	/*
@@ -779,7 +782,7 @@
 	pte_t t;
 
+	assert(istate_from_uspace(istate));
+
 	va = istate->cr_ifa;  /* faulting address */
-
-	assert(!is_kernel_fault(va));
 
 	bool found = page_mapping_find(AS, va, true, &t);
Index: kernel/arch/mips32/Makefile.inc
===================================================================
--- kernel/arch/mips32/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -70,9 +70,4 @@
 	arch/$(KARCH)/src/machine_func.c
 
-ifeq ($(MACHINE),msim)
-	ARCH_SOURCES += \
-		arch/$(KARCH)/src/smp/dorder.c
-endif
-
 ifeq ($(MACHINE),$(filter lmalta bmalta,$(MACHINE)))
 	ARCH_SOURCES += arch/$(KARCH)/src/mach/malta/malta.c
@@ -80,5 +75,7 @@
 
 ifeq ($(MACHINE),msim)
-	ARCH_SOURCES += arch/$(KARCH)/src/mach/msim/msim.c
+	ARCH_SOURCES += \
+		arch/$(KARCH)/src/mach/msim/msim.c \
+		arch/$(KARCH)/src/mach/msim/dorder.c
 endif
 
Index: kernel/arch/mips32/include/arch/arch.h
===================================================================
--- kernel/arch/mips32/include/arch/arch.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/arch.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -42,4 +42,5 @@
 #define CPUMAP_MAX_RECORDS         32
 #define BOOTINFO_TASK_NAME_BUFLEN  32
+#define BOOTINFO_BOOTARGS_BUFLEN   256
 
 extern size_t cpu_count;
@@ -66,4 +67,5 @@
 	uint32_t cpumap;
 	taskmap_t taskmap;
+	char bootargs[BOOTINFO_BOOTARGS_BUFLEN];
 } bootinfo_t;
 
Index: kernel/arch/mips32/include/arch/exception.h
===================================================================
--- kernel/arch/mips32/include/arch/exception.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/exception.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -57,4 +57,19 @@
 #define EXC_VCED   31
 
+#define INT_SW0    0
+#define INT_SW1    1
+#define INT_HW0    2
+#define INT_HW1    3
+#define INT_HW2    4
+#define INT_HW3    5
+#define INT_HW4    6
+#define INT_TIMER  7
+
+#define MIPS_INTERRUPTS    8
+#define HW_INTERRUPTS      (MIPS_INTERRUPTS - 3)
+
+typedef void (*int_handler_t)(unsigned int);
+extern int_handler_t int_handler[];
+
 extern void exception(istate_t *istate);
 extern void tlb_refill_entry(void);
